;*** Includes
.include "m8def.inc"

.def	null	=r1
.def	intf	=r16
.def	work	=r17
.def	inreg	=r18
.def	intf2	=r19
.def	outreg	=r20

.equ 	DI	=4		;//Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
.equ 	DO	=3		;//Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
.equ 	Clk	=5		;//Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
.equ 	CS	=1		;//Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist


.ORG	0
	rjmp	RESET

.ORG	URXCaddr
	rjmp	UART_RXCP

.ORG	UTXCaddr
	rjmp	UART_TXCP



UART_RXCP:
	in 	inreg, 	UDR		; fetch byte from UART data reg. 
	ldi	intf,	1
	set
	reti


UART_TXCP:
	ldi	intf2,	1
	set
	reti




RESET:
	ldi 	work, 	LOW(RAMEND)	; set up stack
	out 	SPL, 	work
	ldi 	work, 	HIGH(RAMEND)
	out 	SPH, 	work					 

	sbi	PORTB,	CS
	cbi	PORTB,	CLK
	sbi	DDRB,	DO
	sbi	DDRB,	CLK
	sbi	DDRB,	CS

	ldi 	work, 	(4000000 / (19200 * 16) - 1)		; baudrate constant 12
	out 	UBRRL, 	work		; prepare baud rate register
	sbi 	UCSRB, 	RXEN		; set "receive enable flag"
	sbi 	UCSRB, 	TXEN		; set "transmitter enable flag"
	sbi 	UCSRB, 	RXCIE		; and "received character interrupt enable flag"
	sbi 	UCSRB, 	TXCIE		; and "received character interrupt enable flag"
	in	work,	UDR
	clr	intf
	clr	intf2
	clr	null
	clr	r0
	sei

	ldi	outreg,	'O'
	rcall	SEND_CHAR
	ldi	outreg,	'K'
	rcall	SEND_CHAR
	ldi	outreg,	13
	rcall	SEND_CHAR
	ldi	outreg,	10
	rcall	SEND_CHAR


MAIN:	brtc	MAIN
	clt

	sbrs	intf,	0
	  rjmp	MAIN
	clr	intf

	; Zeichen empfangen
	cpi	inreg,	'c'
	brne	M1

	rcall	wait
	sbi	PORTB,	CLK
	rcall	wait
	ldi	outreg,	'0'
	sbic	PINB,	DI
	  ldi	outreg,	'1'
	cbi	PORTB,	CLK
	rcall	SEND_CHAR
	rjmp	MAIN

  M1:	cpi	inreg,	'0'
	brne	M2
	cbi	PORTB,	DO
	rjmp	MAIN

  M2:	cpi	inreg,	'1'
	brne	M3
	sbi	PORTB,	DO
	rjmp	MAIN

  M3:	cpi	inreg,	'e'
	brne	M4
	cbi	PORTB,	CS
	rjmp	MAIN

  M4:	cpi	inreg,	'd'
	brne	M4
	sbi	PORTB,	CS
	rjmp	MAIN


SEND_CHAR:
	out	UDR,	outreg
  SC:	sbrs	intf2,	0
	  rjmp	SC
	clt
	clr	intf2
	ret


WAIT:	dec	r0
	brne	WAIT
	ret
